"use strict";

var _pureUuid = require("pure-uuid");

var _pureUuid2 = _interopRequireDefault(_pureUuid);

var _es = require("aggregation/es6");

var _es2 = _interopRequireDefault(_es);

var _gts1Version = require("./gts-1-version");

var _gts1Version2 = _interopRequireDefault(_gts1Version);

var _gts2UtilHook = require("./gts-2-util-hook");

var _gts2UtilHook2 = _interopRequireDefault(_gts2UtilHook);

var _gts3UtilGraphql = require("./gts-3-util-graphql");

var _gts3UtilGraphql2 = _interopRequireDefault(_gts3UtilGraphql);

var _gts4UtilSequelizeOptions = require("./gts-4-util-sequelize-options");

var _gts4UtilSequelizeOptions2 = _interopRequireDefault(_gts4UtilSequelizeOptions);

var _gts5UtilSequelizeFields = require("./gts-5-util-sequelize-fields");

var _gts5UtilSequelizeFields2 = _interopRequireDefault(_gts5UtilSequelizeFields);

var _gts6UtilFts = require("./gts-6-util-fts");

var _gts6UtilFts2 = _interopRequireDefault(_gts6UtilFts);

var _gts7EntityQuery = require("./gts-7-entity-query");

var _gts7EntityQuery2 = _interopRequireDefault(_gts7EntityQuery);

var _gts8EntityCreate = require("./gts-8-entity-create");

var _gts8EntityCreate2 = _interopRequireDefault(_gts8EntityCreate);

var _gts9EntityClone = require("./gts-9-entity-clone");

var _gts9EntityClone2 = _interopRequireDefault(_gts9EntityClone);

var _gtsAEntityUpdate = require("./gts-A-entity-update");

var _gtsAEntityUpdate2 = _interopRequireDefault(_gtsAEntityUpdate);

var _gtsBEntityDelete = require("./gts-B-entity-delete");

var _gtsBEntityDelete2 = _interopRequireDefault(_gtsBEntityDelete);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*  the API class  */
class GraphQLToolsSequelize extends (0, _es2.default)(_gts1Version2.default, _gts2UtilHook2.default, _gts3UtilGraphql2.default, _gts4UtilSequelizeOptions2.default, _gts5UtilSequelizeFields2.default, _gts6UtilFts2.default, _gts7EntityQuery2.default, _gts8EntityCreate2.default, _gts9EntityClone2.default, _gtsAEntityUpdate2.default, _gtsBEntityDelete2.default) {
    constructor(sequelize, options = {}) {
        super(sequelize, options);
        this._sequelize = sequelize;
        this._models = sequelize.models;
        this._idtype = typeof options.idtype === "string" ? options.idtype : "UUID";
        this._idmake = typeof options.idmake === "function" ? options.idmake : () => new _pureUuid2.default(1).format();
        this._anonCtx = function (type) {
            this.__$type$ = type;
        };
        this._anonCtx.prototype.isType = function (type) {
            return this.__$type$ === type;
        };
    }
    boot() {
        return this._ftsBoot();
    }
}

/*  export the traditional way for interoperability reasons
    (as Babel would export an object with a 'default' field)  */


/*  internal dependencies  */
/*
**  GraphQL-Tools-Sequelize -- Integration of GraphQL-Tools and Sequelize ORM
**  Copyright (c) 2016-2017 Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

/*  external dependencies  */
module.exports = GraphQLToolsSequelize;
